<template>
    <div class="referral-v2-information">
        <div v-loading="pageData.isGettingPageData" class="p-4" v-if="pageData.isGettingPageData"></div>
        <el-form label-position="top" label-width="200px" v-else-if="pageData.doesCompanyHaveReferralEvent">
            <div class="left-side">
                <div class="main-section">
                    <div class="w-full flex flex-col">
                        <el-form-item :label="$t('referral_time_left')">
                            <div class="time-left-block">
                                <div class="inner-block" v-show="pageData.timeLeft.days >= 0">
                                    <span class="number">{{ pageData.timeLeft.days }}</span>
                                    <span class="text">{{ $t('days') }}</span>
                                    <span class="number">{{ pageData.timeLeft.hours }}</span>
                                    <span class="text">{{ $t('hours') }}</span>
                                    <span class="number">{{ pageData.timeLeft.minutes }}</span>
                                    <span class="text">{{ $t('minutes') }}</span>
                                    <span class="left" :class="{ 'expired': pageData.timeLeft.days < 1 }">{{ $t('left')
                                    }}</span>
                                </div>
                                <div class="inner-block" v-show="pageData.timeLeft.days < 0">
                                    <span class="left" :class="{ 'expired': pageData.timeLeft.days < 1 }">{{
                                        $t('event_has_ended') }}</span>
                                </div>
                            </div>
                        </el-form-item>
                        <el-form-item :label="$t('referral_link')">
                            <div class="flex w-full gap-2">
                                <div class="referral-text-data"><span class="w-full overflow-x-scroll no-scrollbar">{{ pageData.referralLink }}</span></div>
                                <el-button class="action-button-primary"
                                    @click.prevent="copyTextToClipBoard(pageData.referralLink)">{{ $t('copy')
                                    }}</el-button>
                            </div>
                        </el-form-item>
                        <el-form-item :label="$t('referral_code')">
                            <div class="flex w-full gap-2">
                                <div class="referral-text-data"><span class="w-full truncate">{{ pageData.referralCode
                                }}</span></div>
                                <el-button class="action-button-primary"
                                    @click.prevent="copyTextToClipBoard(pageData.referralCode)">{{ $t('copy')
                                    }}</el-button>
                            </div>
                        </el-form-item>
                    </div>
                    <el-form-item class="qr-code-block-inner">
                        <div class="flex flex-col gap-4 items-center mx-auto">
                            <qrcode-vue id="qrCode1" :value="pageData.referralLink" :size="200"
                                class="p-2 bg-white rounded"></qrcode-vue>
                            <el-button @click.prevent="onDownloadQRCode('qrCode1')"
                                class="w-full action-button-primary" round :loading="pageData.isGeneratingQRCode">
                                <span>{{ $t('download_qr_code') }}</span>
                            </el-button>
                        </div>
                    </el-form-item>
                </div>
                <el-form-item :label="$t('referral_criteria')" class="description" v-if="pageData.criteria">
                    <div class="info-box-block">
                        <el-scrollbar max-height="438">
                            <div v-html="pageData.criteria" class="referral-criteria"></div>
                        </el-scrollbar>
                    </div>
                </el-form-item>
            </div>
            <div class="right-side">
                <el-form-item class="qr-code-block">
                    <div class="flex flex-col gap-4 items-center mx-auto">
                        <qrcode-vue id="qrCode2" :value="pageData.referralLink" :size="200"
                            class="p-2 bg-white rounded"></qrcode-vue>
                        <el-button @click.prevent="onDownloadQRCode('qrCode2')"
                            class="w-full action-button-primary" round :loading="pageData.isGeneratingQRCode">
                            <span>{{ $t('download_qr_code') }}</span>
                        </el-button>
                    </div>
                </el-form-item>
            </div>
        </el-form>
        <p v-else class="text-center capitalize">
            {{ $t('referral_event_coming_soon') }}
        </p>
    </div>
</template>

<script setup lang="ts">
import QrcodeVue from "qrcode.vue";
import { useReferralV2Information } from '~~/composables/referralv2/useReferralV2';

const { pageData, copyTextToClipBoard, onDownloadQRCode, getPageData } = useReferralV2Information();
onMounted(() => {
    getPageData();
});
</script>

<style scoped>
.referral-v2-information {
    padding-bottom: 3rem;
}

.referral-v2-information .el-form {
    width: 100%;
    display: flex;
    gap: 24px;
}

.referral-v2-information .main-section {
    display: flex;
    flex-direction: column;
}

.referral-v2-information .left-side {
    width: 100%;
}

.referral-v2-information .right-side {
    display: none;
}

.referral-v2-information :deep(.el-form-item__label) {
    width: 200px;
}

@media only screen and (min-width: 768px) {
    .referral-v2-information .main-section {
        flex-direction: row;
        gap: 24px;
    }

    .referral-v2-information :deep(.el-form-item.qr-code-block-inner) {
        margin-bottom: 0;
    }
}

@media only screen and (min-width: 1280px) {
    .referral-v2-information :deep(.el-form-item) {
        display: flex;
    }

    .referral-v2-information .right-side {
        display: block;
    }

    .referral-v2-information :deep(.el-form-item .el-form-item__label) {
        margin-bottom: 0;
    }

    .referral-v2-information :deep(.el-form-item.qr-code-block-inner) {
        display: none;
    }
}

.referral-v2-information :deep(.el-form-item:not(.description)) {
    align-items: center;
    margin-bottom: 24px;
}

[layout="china"] .referral-v2-information :deep(.el-form-item__label) {
    color: var(--text);
}
.referral-v2-information :deep(.el-form-item__label) {
    color: var(--text5);
    font-size: 14px;
    font-style: normal;
    font-weight: 500;
    line-height: normal;
    text-transform: capitalize;
}

.referral-v2-information .time-left-block .inner-block {
    display: flex;
    align-items: baseline;
    gap: 4px;
}

.referral-v2-information .time-left-block .left {
    color: var(--success, #03B001);
    text-overflow: ellipsis;
    font-family: Roboto;
    font-size: 14px;
    font-style: normal;
    font-weight: 700;
    line-height: normal;
}

.referral-v2-information .time-left-block .left.expired {
    color: var(--failure, #FF265C);
}

[layout="china"] .referral-v2-information .time-left-block .number {
    color: var(--text);
}
.referral-v2-information .time-left-block .number {
    color: var(--text5);
    text-overflow: ellipsis;
    font-size: 16px;
    font-style: normal;
    font-weight: 700;
    line-height: normal;
}

.referral-v2-information .time-left-block .text {
    color: var(--text5);
    text-overflow: ellipsis;
    font-family: Roboto;
    font-size: 12px;
    font-style: normal;
    font-weight: 400;
    line-height: normal;
}

.referral-v2-information .time-left-block {
    height: 32px;
    padding: 0px 8px;
    width: 100%;
    background-color: rgba(0, 0, 0, 0.1);
    border-radius: 4px;
    display: flex;
    align-items: center;
}

.referral-v2-information .info-box-block {
    border: 1px solid var(--border);
    border-radius: 4px;
    background-color: rgba(0, 0, 0, 0.1);
    padding: 8px;
    width: 100%;
    min-height: 15vh;
}

.referral-v2-information .referral-text-data {
    border: 1px solid var(--border);
    border-radius: 4px;
    background-color: rgba(0, 0, 0, 0.1);
    padding: 8px;
    width: 100%;
    height: 32px;
    position: relative;
    white-space: nowrap;
}

.referral-v2-information .referral-text-data span {
    position: absolute;
    top: 50%;
    left: 8px;
    transform: translateY(-50%);
    white-space: nowrap;
    max-width: 95%;
}
.referral-v2-information .no-scrollbar::-webkit-scrollbar {
    display: none;
}
.referral-v2-information .no-scrollbar.no-scrollbar {
    -ms-overflow-style: none;  /* IE and Edge */
    scrollbar-width: none;  /* Firefox */
}

.referral-v2-information .referral-criteria :deep(table), .referral-v2-information .referral-criteria :deep(td) {
    border-width: thin;
    border-color: var(--border);

}
</style>